<%(&redis_exists("redis_ppages", &concat("pp_id:", %pp_id)) == "0")
	<%|define("error")|PPAGE_DOES_NOT_EXIST%>
::
	<%|redis_hgetall("redis_ppages", &concat("pp_id:", %pp_id), "promo")|
		/* We dont want the banner being shown longer than the page */

		<%(&format_date("%s", %start_date) > &format_date("%s", %promo_start_date))
			<%|define("later_start_date")|%start_date%>
		::
			<%|define("later_start_date")|%promo_start_date%>
		%>

		<%(%end_date != "")
			<%(%promo_end_date != "")
				<%(&format_date("%s", %end_date) < &format_date("%s", %promo_end_date))
					<%|define("earlier_end_date")|%end_date%>
				::
					<%|define("earlier_end_date")|%promo_end_date%>
				%>
			::
				<%|define("earlier_end_date")|%end_date%>
			%>
		::(%promo_end_date != "")
			<%|define("earlier_end_date")|%promo_end_date%>
		%>
	%>

	<%|redis_keys("redis_banners", &concat("*", $(ppages.banner.prefix), %platform, ":", %position, ":*"), "keys")|
	<%|@loop("keys")|
		<%((%keys != %key) && (%keys != &concat("draft:", %key)))
			/* We dont want two banners at the same time */
			<%|redis_hgetall("redis_banners", %keys, "other")|
				/* For listing, check if a category of the inserted banner already exists in another */
				<%(%position == "listing")
					<%|varblock|
						<%|define_split("cats")|$(other.categories)%>
						<%|@loop("categories")|
							<%(&in_list(%categories, "cats") != "")
								<%|define_global("cat_overlap")|1%>
							%>
						%>
					%>
				%>
				<%(&format_date("%s", %later_start_date) >= &format_date("%s", $(other.start_date)))
					<%($(other.end_date) == "" || &format_date("%s", $(other.end_date)) >= &format_date("%s", %later_start_date))
						<%(?cat_overlap)
							<%|define("error")|BANNER_CATEGORY_OVERLAP%>
						::(%position != "listing")
							<%|define("error")|BANNER_DATE_OVERLAP%>
						%>
					%>
				::(&format_date("%s", %earlier_end_date) >= &format_date("%s", $(other.start_date)))
					<%(?cat_overlap)
						<%|define("error")|BANNER_CATEGORY_OVERLAP%>
					::(%position != "listing")
						<%|define("error")|BANNER_DATE_OVERLAP%>
					%>
				%>
			%>
		%>
	%>
	%>

	<%(!?error || %error == "")
		<%(?key && %key != "")
			<%|define("banner_id")|<%&redis_hget("redis_banners", %key, "banner_id")%>%>
			<%&redis_del("redis_banners", %key)%>
		::
			<%|define("banner_id")|<%&redis_incr("redis_banners", "banners_pp")%>%>
		%>
		<%|define("replace_key")|$(ppages.banner.prefix)%platform:%position:%banner_id%>
		<%|define("hash")|draft:%replace_key%>
		<%|redis_hset("redis_banners", %hash, "key")|%hash%>
		<%|redis_hset("redis_banners", %hash, "pp_id")|%pp_id%>
		<%|redis_hset("redis_banners", %hash, "url")|%url%>
		<%|redis_hset("redis_banners", %hash, "start_date")|%later_start_date%>
		<%|redis_hset("redis_banners", %hash, "image")|%image%>
		<%|redis_hset("redis_banners", %hash, "end_date")|<%(?earlier_end_date && %earlier_end_date!="")%earlier_end_date::-1%>%>
		<%|redis_hset("redis_banners", %hash, "banner_id")|%banner_id%>
		<%|redis_hset("redis_banners", %hash, "platform")|%platform%>
		<%|redis_hset("redis_banners", %hash, "position")|%position%>
		<%|redis_hset("redis_banners", %hash, "categories")|<%(?categories)<%@categories<%(@@# < &(#@@-1)),%>%>::-1%>%>
		<%|redis_hset("redis_banners", %hash, "regions")|<%(?regions)<%@regions<%(@@# < &(#@@-1)),%>%>::-1%>%>
		banner_id:%banner_id
	%>

%>
